Merge remote-tracking branch 'alexis/lib-jvm'
[nit.git] / tests / tests.sh
index b10a75b..44ae356 100755 (executable)
 
 # Set lang do default to avoid failed tests because of locale
 export LANG=C
+export NIT_TESTING=true
+
+unset NIT_DIR
+
+# Get the first Java lib available
+shopt -s nullglob
+paths=`echo /usr/lib/jvm/*/`
+paths=($paths) 
+JAVA_HOME=${paths[0]}
+
+paths=`echo $JAVA_HOME/jre/lib/*/{client,server}/`
+paths=($paths) 
+JNI_LIB_PATH=${paths[0]}
+shopt -u nullglob
 
 usage()
 {
@@ -29,7 +43,7 @@ Usage: $e [options] modulenames
 -v          Verbose (show tests steps)
 -h          This help
 --tap       Produce TAP output
---engine    Use a specific engine (default=nitc)
+--engine    Use a specific engine (default=nitg)
 --noskip    Do not skip a test even if the .skip file matches
 --[no]soso  Force enable (or disable) SOSO
 END
@@ -47,7 +61,7 @@ function compare_to_result()
        local pattern="$1"
        local sav="$2"
        if [ ! -r "$sav" ]; then return 0; fi
-       diff -u "out/$pattern.res" "$sav" > "out/$pattern.diff.sav.log"
+       diff -u "$sav" "out/$pattern.res" > "out/$pattern.diff.sav.log"
        if [ "$?" == 0 ]; then
                return 1
        fi
@@ -56,7 +70,7 @@ function compare_to_result()
        sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
        grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
        grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
-       diff -u "out/$pattern.res2" "out/$pattern.sav2" > "out/$pattern.diff.sav2.log"
+       diff -u "out/$pattern.sav2" "out/$pattern.res2" > "out/$pattern.diff.sav.log"
        if [ "$?" == 0 ]; then
                return 2
        else
@@ -71,6 +85,7 @@ function process_result()
        # Result
        pattern=$1
        description=$2
+       pack=$3
        SAV=""
        NSAV=""
        FIXME=""
@@ -79,48 +94,69 @@ function process_result()
        NSOSO=""
        SOSOF=""
        NSOSOF=""
-       for sav in "sav/$engine/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
+       OLD=""
+       LIST=""
+       FIRST=""
+       echo >>$xml "<testcase classname='$pack' name='$description'>"
+       #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
+       for savdir in $savdirs; do
+               sav=$savdir/$pattern.res
                compare_to_result "$pattern" "$sav"
-               case "$?" in
-                       0)
-                               ;; # no file
-                       1)
-                               SAV="$sav" ;;
-                       2)
-                               SOSO="$sav" ;;
-                       3)
-                               NSAV="$sav";;
-               esac
-       done
-       for sav in "sav/$engine/fixme/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.fail"; do
-               compare_to_result "$pattern" "$sav"
-               case "$?" in
-                       0)
-                               ;; # no file
-                       1)
-                               FIXME="$sav" ;;
-                       2)
+
+               case "$? $sav" in
+                       0*)
+                               continue;; # no file
+                       1*/fixme/*)
+                               OLD="$LIST"
+                               FIXME="$sav"
+                               ;;
+                       1*)
+                               OLD="$LIST"
+                               SAV="$sav"
+                               ;;
+                       2*/fixme/*)
                                SOSOF="$sav" ;;
-                       3)
-                               NFIXME="$sav";;
+                       2*)
+                               SOSO="$sav" ;;
+                       3*/fixme/*)
+                               if [ -z "$FIRST" ]; then
+                                       NFIXME="$sav"
+                                       FIRST="$sav"
+                               fi
+                               ;;
+                       3*)
+                               if [ -z "$FIRST" ]; then
+                                       NSAV="$sav"
+                                       FIRST="$sav"
+                               fi
+                               ;;
                esac
+               LIST="$LIST $sav"
        done
+       OLD=`echo "$OLD" | sed -e 's/   */ /g' -e 's/^ //' -e 's/ $//'`
        grep 'NOT YET IMPLEMENTED' "out/$pattern.res" >/dev/null
        NYI="$?"
        if [ -n "$SAV" ]; then
                if [ -n "$tap" ]; then
                        echo "ok - $description"
-               elif [ -z "$FIXME" ]; then
-                       echo "[ok] out/$pattern.res $SAV"
+               elif [ -n "$OLD" ]; then
+                       echo "[*ok*] out/$pattern.res $SAV - but $OLD remains!"
+                       echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
+                       remains="$remains $OLD"
                else
-                       echo "[ok] out/$pattern.res $SAV - but $FIXME remains!"
+                       echo "[ok] out/$pattern.res $SAV"
                fi
                ok="$ok $pattern"
        elif [ -n "$FIXME" ]; then
                if [ -n "$tap" ]; then
                        echo "not ok - $description # TODO expected failure"
+               elif [ -n "$OLD" ]; then
+                       echo "[*fixme*] out/$pattern.res $FIXME - but $OLD remains!"
+                       echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
+                       remains="$remains $OLD"
                else
                        echo "[fixme] out/$pattern.res $FIXME"
+                       echo >>$xml "<skipped/>"
                fi
                todos="$todos $pattern"
        elif [ -n "$SOSO" ]; then
@@ -135,6 +171,7 @@ function process_result()
                        echo "not ok - $description # TODO not yet implemented"
                else
                        echo "[todo] out/$pattern.res -> not yet implemented"
+                       echo >>$xml "<skipped/>"
                fi
                todos="$todos $pattern"
        elif [ -n "$SOSOF" ]; then
@@ -142,6 +179,7 @@ function process_result()
                        echo "not ok - $description # TODO SOSO expected failure"
                else
                        echo "[fixme soso] out/$pattern.res $SOSOF"
+                       echo >>$xml "<skipped/>"
                fi
                todos="$todos $pattern"
        elif [ -n "$NSAV" ]; then
@@ -150,6 +188,10 @@ function process_result()
                else
                        echo "[======= fail out/$pattern.res $NSAV =======]"
                fi
+               echo >>$xml "<error message='fail out/$pattern.res $NSAV'/>"
+               echo >>$xml "<system-out><![CDATA["
+               cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
+               echo >>$xml "]]></system-out>"
                nok="$nok $pattern"
                echo "$ii" >> "$ERRLIST"
        elif [ -n "$NFIXME" ]; then
@@ -158,6 +200,10 @@ function process_result()
                else
                        echo "[======= changed out/$pattern.res $NFIXME ======]"
                fi
+               echo >>$xml "<error message='changed out/$pattern.res $NFIXME'/>"
+               echo >>$xml "<system-out><![CDATA["
+               cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
+               echo >>$xml "]]></system-out>"
                nok="$nok $pattern"
                echo "$ii" >> "$ERRLIST"
        else
@@ -166,8 +212,18 @@ function process_result()
                else
                        echo "[=== no sav ===] out/$pattern.res"
                fi
+               echo >>$xml "<skipped/>"
+               echo >>$xml "<system-out><![CDATA["
+               cat -v >>$xml out/$pattern.res
+               echo >>$xml "]]></system-out>"
                nos="$nos $pattern"
        fi
+       if test -s out/$pattern.cmp.err; then
+               echo >>$xml "<system-err><![CDATA["
+               cat -v >>$xml out/$pattern.cmp.err
+               echo >>$xml "]]></system-err>"
+       fi
+       echo >>$xml "</testcase>"
 }
 
 need_skip()
@@ -180,6 +236,7 @@ need_skip()
                else
                        echo "=> $2: [skip]"
                fi
+               echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
                return 0
        fi
        return 1
@@ -192,17 +249,17 @@ find_nitc()
        recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
        if [[ "x$recent" == "x" ]]; then
                if [ -n "$tap" ]; then
-                       echo "not ok - find engine $name"
-                       echo "Bail out! Could not find engine $name, aborting"
+                       echo "not ok - find binary for $engine"
+                       echo "Bail out! Could not find binary for engine $engine, aborting"
                else
-                       echo "Could not find engine $name, aborting"
+                       echo "Could not find binary for engine $engine, aborting"
                fi
                exit 1
        fi
        if [ -n "$tap" ]; then
-               echo "ok - find engine $name: $recent"
+               echo "ok - find binary for $engine: $recent $OPT"
        else
-               echo "Using engine $name from: $recent"
+               echo "Find binary for engine $engine: $recent $OPT"
        fi
        NITC=$recent
 }
@@ -210,7 +267,7 @@ find_nitc()
 verbose=false
 stop=false
 tapcount=0
-engine=nitc
+engine=nitg
 noskip=
 while [ $stop = false ]; do
        case $1 in
@@ -227,12 +284,43 @@ while [ $stop = false ]; do
 done
 enginebinname=$engine
 case $engine in
-       nitc) ;;
-       nitg) ;;
-       nitg-s) enginebinname=nitg; OPT="--separate $OPT";;
-       nitg-e) enginebinname=nitg; OPT="--erasure $OPT";;
-       nit) engine=niti ;;
-       niti) enginebinname=nit ;;
+       nitg)
+               engine=nitg-s;
+               enginebinname=nitg;
+               savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
+               OPT="--separate $OPT"
+               ;;
+       nitg-s)
+               enginebinname=nitg;
+               savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
+               OPT="--separate $OPT"
+               ;;
+       nitg-e)
+               enginebinname=nitg;
+               savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
+               OPT="--erasure $OPT"
+               ;;
+       nitg-g)
+               enginebinname=nitg;
+               savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
+               OPT="--global $OPT"
+               ;;
+       nit)
+               engine=niti
+               savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
+               ;;
+       niti)
+               enginebinname=nit
+               savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
+               ;;
+       nitc)
+               echo "disabled engine $engine"
+               exit 0
+               ;;
+       *)
+               echo "unknown engine $engine"
+               exit 1
+               ;;
 esac
 
 # The default nitc compiler
@@ -241,6 +329,13 @@ esac
 # Set NIT_DIR if needed
 [ -z "$NIT_DIR" ] && export NIT_DIR=..
 
+if sh -c "timelimit echo" 1>/dev/null 2>&1; then
+       TIMEOUT="timelimit -t 600"
+elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
+       TIMEOUT="timeout 600s"
+else
+       echo "No timelimit or timeout command detected. Tests may hang :("
+fi
 
 # Mark to distinguish files among tests
 # MARK=
@@ -266,6 +361,8 @@ fi
 ok=""
 nok=""
 todos=""
+xml="tests-$engine.xml"
+echo >$xml "<testsuites><testsuite>"
 
 # CLEAN the out directory
 rm -rf out/ 2>/dev/null
@@ -278,8 +375,10 @@ for ii in "$@"; do
        fi
        f=`basename "$ii" .nit`
 
+       pack=`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
+
        # Sould we skip the file for this engine?
-       need_skip $f $f && continue
+       need_skip $f $f $pack && continue
 
        tmp=${ii/../AA}
        if [ "x$tmp" = "x$ii" ]; then
@@ -293,7 +392,7 @@ for ii in "$@"; do
                ff="out/$bf"
 
                # Sould we skip the alternative for this engine?
-               need_skip $bf $bf && continue
+               need_skip $bf $bf $pack && continue
 
                test -z "$tap" && echo -n "=> $bf: "
 
@@ -317,7 +416,8 @@ END
                                echo ""
                                echo $NITC --no-color $OPT -o "$ff.bin" "$i" "$includes"
                        fi
-                       NIT_NO_STACK=1 $NITC --no-color $OPT -o "$ff.bin" "$i" $includes 2> "$ff.cmp.err" > "$ff.compile.log"
+                       NIT_NO_STACK=1 JNI_LIB_PATH=$JNI_LIB_PATH JAVA_HOME=$JAVA_HOME \
+                               $TIMEOUT $NITC --no-color $OPT -o "$ff.bin" "$i" $includes 2> "$ff.cmp.err" > "$ff.compile.log"
                        ERR=$?
                        if [ "x$verbose" = "xtrue" ]; then
                                cat "$ff.compile.log"
@@ -327,7 +427,7 @@ END
                if [ "$ERR" != 0 ]; then
                        test -z "$tap" && echo -n "! "
                        cat "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
-                       process_result $bf $bf
+                       process_result $bf $bf $pack
                elif [ -x "./$ff.bin" ]; then
                        test -z "$tap" && echo -n ". "
                        # Execute
@@ -335,8 +435,9 @@ END
                        if [ "x$verbose" = "xtrue" ]; then
                                echo ""
                                echo "NIT_NO_STACK=1 ./$ff.bin" $args
-                       fi
-                       NIT_NO_STACK=1 "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
+                       fi      
+                       NIT_NO_STACK=1 LD_LIBRARY_PATH=$JNI_LIB_PATH \
+                               $TIMEOUT "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
                        if [ "x$verbose" = "xtrue" ]; then
                                cat "$ff.res"
                                cat >&2 "$ff.err"
@@ -348,7 +449,7 @@ END
                        fi
                        cp "$ff.res"  "$ff.res2"
                        cat "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
-                       process_result $bf $bf
+                       process_result $bf $bf $pack
 
                        if [ -f "$f.args" ]; then
                                fargs=$f.args
@@ -358,17 +459,27 @@ END
                                        args="$line"
                                        bff=$bf"_args"$cptr
                                        fff=$ff"_args"$cptr
+                                       name="$bf args $cptr"
 
                                        # Sould we skip the input for this engine?
-                                       need_skip $bff "  args #$cptr" && continue
+                                       need_skip $bff "  $name" $pack && continue
+
+                                       # use a specific inputs file, if required
+                                       if [ -f "$bff.inputs" ]; then
+                                               ffinputs="$bff.inputs"
+                                       else
+                                               ffinputs=$inputs
+                                       fi
 
                                        rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
                                        if [ "x$verbose" = "xtrue" ]; then
                                                echo ""
                                                echo "NIT_NO_STACK=1 ./$ff.bin" $args
                                        fi
-                                       test -z "$tap" && echo -n "==> args #"$cptr " "
-                                       sh -c "NIT_NO_STACK=1 ./$ff.bin  ''$args < $inputs > $fff.res 2>$fff.err"
+                                       test -z "$tap" && echo -n "==> $name "
+                                       echo "./$ff.bin $args" > "./$fff.bin"
+                                       chmod +x "./$fff.bin"
+                                       WRITE="$fff.write" sh -c "NIT_NO_STACK=1 $TIMEOUT ./$fff.bin < $ffinputs > $fff.res 2>$fff.err"
                                        if [ "x$verbose" = "xtrue" ]; then
                                                cat "$fff.res"
                                                cat >&2 "$fff.err"
@@ -382,14 +493,17 @@ END
                                                cp "$fff.res"  "$fff.res2"
                                                cat "$fff.err" "$fff.res2" > "$fff.res"
                                        fi
-                                       process_result $bff "  args #$cptr"
+                                       process_result $bff "  $name" $pack
                                done < $fargs
                        fi
+               elif [ -f "./$ff.bin" ]; then
+                       echo "Not executable (platform?)" > "$ff.res"
+                       process_result $bf "$bf" $pack
                else
                        test -z "$tap" && echo -n "! "
                        cat "$ff.cmp.err" > "$ff.res"
                        echo "Compilation error" > "$ff.res"
-                       process_result $bf "$bf"
+                       process_result $bf "$bf" $pack
                fi
        done
 done
@@ -400,9 +514,11 @@ if [ -n "$tap" ]; then
        echo "# not ok:" `echo $nok | wc -w`
        echo "# no sav:" `echo $nos | wc -w`
        echo "# todo/fixme:" `echo $todos | wc -w`
+       echo "# of sav that remains:" `echo $remains | wc -w`
        exit
 fi
 
+echo "engine: $engine ($enginebinname $OPT)"
 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
 
 if [ -n "$nok" ]; then
@@ -415,6 +531,9 @@ fi
 if [ -n "$todos" ]; then
        echo "todo/fixme: $todos"
 fi
+if [ -n "$remains" ]; then
+       echo "sav that remains: $remains"
+fi
 
 # write $ERRLIST
 if [ "x$ERRLIST" != "x" ]; then
@@ -424,6 +543,8 @@ if [ "x$ERRLIST" != "x" ]; then
        mv $ERRLIST $ERRLIST_TARGET
 fi
 
+echo >>$xml "</testsuite></testsuites>"
+
 if [ -n "$nok" ]; then
        exit 1
 else